#include "DocumentSpace.h"


#include <iostream>
#include <fstream>


// load a sequence of documents as described in meta file
//
DocumentSpace::docID DocumentSpace::loadDocuments(const char * metafile){

  std::ifstream infile;
  std::string line;
  char filename[255];
  
  docID currentDoc = 0;

  infile.open(metafile, std::ios_base::in);
  // open the file

  if (!infile) {
    std::cerr << "Cannot open file " << metafile << std::endl;
    return 0;
  };

  while(infile){

    infile.getline(filename, 255);
    if (!infile.eof() && filename){
      loadDocument(filename);
      //    std::cout << "Loaded file " << std::string(filename) << std::endl;
      currentDoc++;
    }
  }
  
  infile.close();

  return currentDoc-1;
};


// load document

void DocumentSpace::loadDocument(const char * filename){

  std::ifstream infile;
  infile.open(filename, std::ios_base::in);
  
  // open the file

  if (!infile) {
    std::cerr << "Cannot open file " << filename << std::endl;
    return;
  };

  // load the whole document as a string
  std::string doc((std::istreambuf_iterator<char>(infile)), std::istreambuf_iterator<char>());

  // close the file
  infile.close();

  ds_.push_back(make_pair(doc, std::string(filename)));
};


// dump a single document


void DocumentSpace::dumpDocument(docID di) const{
  
  std::cout << "`" << ds_[di].second << "'\t" 
	    <<ds_[di].first << std::endl;
}


// dump all the documents

void DocumentSpace::dumpDocuments() const{

  DS::const_iterator end = ds_.end();

  docID di = 0;
  for (DS::const_iterator it = ds_.begin();
       it != end;
       it ++){

    std::cout << "docId:" << ++di << it->first  <<"\n";
  }
}


